//todo-- add full lasik header
//Author: Ian Goodfelow
//Description-- a class used for callbacks for custom colorings of renderable meshes

#pragma once

#include "svlAbstractCloud.h"

class svlPointColourer
{
 public:
  //default is no-op
  virtual void preprocess(const svlAbstractCloud * cloud) const ;


  virtual void colour(const svlPoint3d & pt, const svlAbstractCloud * cloud) const = 0;
};

class svlDepthColourer : public svlPointColourer
{
 public:
  
  svlDepthColourer(double orig_x, double orig_y, double orig_z);
  void colour(const svlPoint3d & pt, const svlAbstractCloud * cloud) const;


 protected:

  svlPoint3d _origin;
  svlPoint3d _nearColor;
  svlPoint3d _farColor;
  double _nearDist;
  double _farDist;
};
